<template>
  <div class="col-7 px-0" ref="chatbox">
    <div class="px-4 py-5 chat-box bg-white">
      <!-- Sender Message-->
      <div class="media d-flex align-items-center justify-content-start">
        <img
          src="https://bootstrapious.com/i/snippets/sn-chat/avatar.svg"
          alt="user"
          width="50"
          class="rounded-circle"
        />
        <div class="media-body ml-3">
          <div class="bg-light rounded py-2 px-3 mb-2">
            <p class="text-small mb-0 text-muted">
              Test which is a new approach all solutions
            </p>
          </div>
          <p class="small text-muted">12:00 PM | Aug 13</p>
        </div>
      </div>

      <!-- Reciever Message-->
      <div class="media d-flex align-items-center justify-content-end">
        <div class="media-body">
          <div class="bg-primary rounded py-2 px-3 mb-2">
            <p class="text-small mb-0 text-white">
              Test which is a new approach to have all solutions
            </p>
          </div>
          <p class="small text-muted">12:00 PM | Aug 13</p>
        </div>
        <img
          src="https://bootstrapious.com/i/snippets/sn-chat/avatar.svg"
          alt="user"
          width="50"
          class="rounded-circle"
        />
      </div>
    </div>

    <!-- Typing area -->
    <div class="input-group">
      <input
        type="text"
        placeholder="Type a message"
        aria-describedby="button-addon2"
        class="form-control rounded-0 border-0 py-4 bg-light"
        v-model="message"
        @keyup.enter="sendMessage"
      />
      <div class="input-group-append">
        <button
          id="button-addon2"
          type="submit"
          class="btn btn-link"
          @click="callMe()"
          :disabled="disableBtnSend"
        >
          <i class="fa fa-paper-plane"></i>
        </button>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    chat: {
      type: String,
    },
  },
  data() {
    return {
      message: "",
      messages: [],
      disableBtnSend: true,
      isConnected: true,
    };
  },
  sockets: {
    connect() {
      // Fired when the socket connects.
      this.isConnected = true;
    },

    disconnect() {
      this.isConnected = false;
    },

    // Fired when the server sends something on the "messageChannel" channel.
    messageChannel(data) {
      this.message = data;
    },
  },
  methods: {
    callMe() {
      console.log("callme");
      this.$socket.emit("pingServer", "PING!");
    },
    sendMessage() {
      console.log(this.message);
      //   axios
      //     .post("/sendMessage", this.message)
      //     .then((res) => {
      //       console.log(res);
      //     })
      //     .catch((err) => {
      //       console.error(err);
      //     });
      this.$nextTick(() => {
        this.$refs.chatbox.scrollTop = this.$refs.chatbox.scrollHeight;
      });

      this.message = "";
    },
  },
  watch: {
    chat: function () {
      this.callMe();
    },
    message: {
      handler: function (val) {
        this.disableBtnSend = val != "" ? false : true;
      },
      immediate: true,
    },
  },
};
</script>

<style></style>
